# Copyright (C) 2001,2002 Tuomo Makinen (tmakinen@pp.htv.fi)
# Licensed under the terms of the GNU General Public License
# client.py v. 0.1.3

import os
import string
import cPickle
import md5
from sec import key_generator, encipher, decipher

PROTOCOL_ERROR = "Protocol error"
KEY_REQUEST = "102:"
INTERRUPT_SCAN = "104"
STATUSHEADERS = ("103",
                 "201",
                 "203",
                 "401",
                 "402",
                 "403",
                 "404",
                 "405",
                 "406",
                 "407")

def signal_handler_sigalrm(signum, frame):
    # Interrupt connect()
    return

def save_key(key, server):
    try:
        fp = open(os.environ["HOME"] + "/.rnmap.keys", "a")
    except IOError:
        pass
    else:
        fp.write(server + ": " + key + "\n###\n") 
        fp.close()

def fetch_key(server):
    publickey = None
    try:
        fp = open(os.environ["HOME"] + "/.rnmap.keys")
    except IOError:
        pass
    else:
        keyfile = fp.read()
        key_start = string.find(keyfile, server)
        key_stop = string.find(keyfile, "###", key_start)
        if key_start != -1:
            publickey = keyfile[key_start + len(server) + 2:key_stop-1]
            try:
                publickey = cPickle.loads(publickey)
            except:
                publickey = -1
    return publickey
            
def generate_message(logid, passwd, publickey, payload):
    key = key_generator(16)
    iv = key_generator(8)
    ciphered = encipher(logid + ":" + passwd + ":" + payload, key, iv)
    ciphered_key = publickey.encrypt("key: " + key, '')
    message = "101:" + ciphered + ":: " + ciphered_key[0] + iv
    return message, key

def get_pubkey(passwd, message):
    iv = message[-8:]
    sharedsec = md5.new(passwd).digest()
    try:
        spkey = decipher(message[:-8], sharedsec, iv)
    except TypeError, e:
        spkey = -1
    return spkey
