# Copyright (C) 2001 Tuomo Makinen (tmakinen@pp.htv.fi)
# Licensed under the terms of the GNU General Public License
# pubkey.py v. 0.1.2

from sec import key_generator
import cPickle
import sys
import os.path

def pub_keys(keylength, conf_dir):
    pubkey_stat = 1
    private_key = os.path.join(conf_dir, "rnmap_private.key")
    public_key = os.path.join(conf_dir, "rnmap_public.key")
    try:
        fp_1 = open(private_key)
        fp_2 = open(public_key)
    except IOError:
        from Crypto.PublicKey import RSA
        sys.stdout.write("Generating RSA keys ...")
        sys.stdout.flush()
        RSA_key = RSA.generate(keylength, key_generator)
        Pub_key = RSA_key.publickey()
        fp_1 = open(private_key, "w")
        fp_2 = open(public_key, "w")
        p_1 = cPickle.Pickler(fp_1)
        p_1.dump(RSA_key)
        fp_1.close()
        p_2 = cPickle.Pickler(fp_2)
        p_2.dump(Pub_key)
        fp_2.close()
        Publickey = cPickle.dumps(Pub_key)
        sys.stdout.write("\n")
    else:
        try:
            u_1 = cPickle.Unpickler(fp_1)
            RSA_key = u_1.load()
            fp_1.close()
            Publickey = fp_2.read()
        except:
            pubkey_stat = 0
            
    return RSA_key, Publickey, pubkey_stat
